#pragma once

#include "Messages.h"

namespace Passer {
namespace Control {

/// @brief A client message announces the presence of a participant
/// When received by another participant, it can be followed by a NetworkIdMsg
/// to announce that participant to this client such that it can join privately
class ClientMsg : public IMessage {
public:
  static const unsigned char id = 0xA0;
  static const unsigned char length = 2;
  unsigned char networkId;

  ClientMsg(char networkId);
  ClientMsg(const char *buffer);
  virtual ~ClientMsg();

  virtual unsigned char Serialize(char *buffer) override;
};

} // namespace Control
} // namespace Passer